package ee.yoursit.core.command.bukkit.api;

import ee.yoursit.core.YsmpCore;
import org.bukkit.command.PluginCommand;

import java.util.Arrays;

public class Command extends Argument {
    public final void register() {
        PluginCommand command = YsmpCore.INSTANCE.getPlugin().getCommand(getName());
        if (command == null)
            throw new IllegalStateException("Command '" + getName() + "' is not registered in the plugin.yml");

        command.setExecutor((sender, cmd, label, args) -> {
            execute(sender, args);
            return true;
        });
        command.setTabCompleter((sender, cmd, label, args) -> complete(sender, args).getData());
        command.setAliases(Arrays.asList(getAliases()));
    }

    public final void unregister() {
        PluginCommand command = YsmpCore.INSTANCE.getPlugin().getCommand(getName());
        if (command == null)
            throw new IllegalStateException("Command '" + getName() + "' is not registered in the plugin.yml");

        command.setExecutor(null);
        command.setTabCompleter(null);
    }
}
