package ee.yoursit.core.command.bukkit.api;

import lombok.AllArgsConstructor;
import lombok.Getter;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

@AllArgsConstructor
public class Completion {
    public final static Completion EMPTY = of(Collections.emptyList());

    public final static Completion PLAYERS = of((List<String>) null);

    @Nullable
    @Getter
    private final List<String> data;

    public Completion push(@NotNull String element) {
        assert data != null : "Cannot push element to PLAYER_LIST completion";
        data.add(element);
        return this;
    }

    public static Completion of(List<String> data) {
        return new Completion(data != null ? new ArrayList<>(data) : null);
    }

    public static Completion of(String... data) {
        return new Completion(new ArrayList<>(Arrays.asList(data)));
    }

    public static Completion of(Stream<String> data) {
        return new Completion(data != null ? data.collect(Collectors.toList()) : null);
    }

    public static Completion empty() {
        return new Completion(new ArrayList<>());
    }
}
