package ee.yoursit.core.data;

import com.google.common.collect.Maps;
import ee.yoursit.core.YsmpCore;
import lombok.Getter;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

import java.util.*;

@Getter
public class DataManager {
    private final Map<UUID, PlayerData> playerData = Maps.newConcurrentMap();

    public DataManager() {
        Bukkit
            .getOnlinePlayers()
            .forEach(this::add);

        Bukkit
            .getScheduler()
            .scheduleSyncRepeatingTask(YsmpCore.INSTANCE.getPlugin(),
                this::updateOnline, 20 * 60, 20 * 60);
    }

    private void updateOnline() {
        playerData
            .values()
            .forEach(PlayerData::updateLastOnline);
    }

    public PlayerData add(Player player) {
        PlayerData data = new PlayerData(player);
        playerData.put(player.getUniqueId(), data);
        return data;
    }

    public PlayerData remove(Player player) {
        return playerData.remove(player.getUniqueId());
    }

    public PlayerData get(Player player) {
        return playerData.get(player.getUniqueId());
    }

    public PlayerData get(UUID uuid) {
        return playerData.get(uuid);
    }
}
