package ee.yoursit.core.database;

import com.mongodb.MongoClient;
import com.mongodb.client.MongoCollection;
import com.mongodb.client.MongoDatabase;
import ee.yoursit.core.database.entity.impl.*;
import lombok.Getter;
import org.bson.Document;

@Getter
public class Database {
    private final String host;
    private final int port;

    private MongoClient client;

    private MongoCollection<Document> users, groups, invites, bans, verifications;

    public Database(String host, int port) {
        this.host = host;
        this.port = port;
    }

    public void connect() {
        client = new MongoClient(host, port);

        MongoDatabase database = client.getDatabase("ysmp");

        User.setCollection(users = database.getCollection("users"));
        Group.setCollection(groups = database.getCollection("groups"));
        Invite.setCollection(invites = database.getCollection("invites"));
        Ban.setCollection(bans = database.getCollection("bans"));
        Verification.setCollection(verifications = database.getCollection("verifications"));
    }

    public void disconnect() {
        client.close();
    }
}
