package ee.yoursit.core.database.entity.api;

import dev.inventex.octa.concurrent.future.Future;

import java.util.HashMap;
import java.util.Map;

public class MapEntityProperty<K, V> extends EntityProperty<Map<K, V>> {
    public MapEntityProperty(Entity entity, String name, Class<Map<K, V>> type, Map<K, V> value) {
        super(entity, name, type, value);
    }

    public MapEntityProperty(Entity entity, String name, Class<Map<K, V>> type) {
        super(entity, name, type);
    }

    @MutateEntity
    public Future<V> set(K key, V value) {
        Map<K, V> map = get();
        if (map == null)
            init(map = new HashMap<>());
        V oldValue = map.put(key, value);
        return mutate().transform(e -> oldValue);
    }

    @MutateEntity
    public Future<V> unset(K key) {
        Map<K, V> map = get();
        if (map == null)
            return null;
        V oldValue = map.remove(key);
        return mutate().transform(e -> oldValue);
    }

    public V get(K key) {
        Map<K, V> map = get();
        if (map == null)
            return null;
        return map.get(key);
    }
}
