package ee.yoursit.core.database.entity.impl;

import com.mongodb.client.MongoCollection;
import com.mongodb.client.model.Filters;
import ee.yoursit.core.database.entity.api.Entity;
import ee.yoursit.core.database.entity.api.EntityProperty;
import lombok.Getter;
import lombok.Setter;
import org.bson.Document;
import org.bson.conversions.Bson;

import java.util.UUID;

@Getter
public class Ban implements Entity {
    @Setter
    private static MongoCollection<Document> collection;

    private EntityProperty<UUID> banId, moderator, target;

    private EntityProperty<String> reason;

    private EntityProperty<Long> timestamp;

    @Override
    public Bson query() {
        return Filters.eq("banId", banId.get().toString());
    }

    public static Bson queryId(UUID banId) {
        return Filters.eq("banId", banId.toString());
    }

    public static Bson queryTarget(UUID target) {
        return Filters.eq("target", target.toString());
    }

    @Override
    public MongoCollection<Document> collection() {
        return collection;
    }
}
