package ee.yoursit.core.database.entity.impl;

import com.mongodb.client.MongoCollection;
import ee.yoursit.core.database.entity.api.Entity;
import ee.yoursit.core.database.entity.api.EntityProperty;
import ee.yoursit.core.database.entity.api.ListEntityProperty;
import lombok.Getter;
import lombok.Setter;
import org.bson.Document;
import org.bson.conversions.Bson;
import org.bukkit.Location;

import java.util.UUID;

import static com.mongodb.client.model.Filters.*;

@Getter
public class User implements Entity {
    @Setter
    private static MongoCollection<Document> collection;

    private EntityProperty<String> username;
    private EntityProperty<UUID> uuid;
    private EntityProperty<Long> discordId;

    private EntityProperty<Long> registered;
    private EntityProperty<Long> lastOnline;
    private EntityProperty<Long> playTime;

    private EntityProperty<String> group;
    private EntityProperty<Location> home;

    private EntityProperty<Boolean> banned;

    private EntityProperty<String> invite;
    private ListEntityProperty<String> invites;

    public static Bson query(UUID uuid) {
        return eq("uuid", uuid.toString());
    }

    public static Bson query(String username) {
        return eq("username", username);
    }

    @Override
    public Bson query() {
        return eq("uuid", uuid.get().toString());
    }

    @Override
    public MongoCollection<Document> collection() {
        return collection;
    }
}
