package ee.yoursit.core.database.service;

import dev.inventex.octa.concurrent.future.Future;
import ee.yoursit.core.YsmpCore;
import ee.yoursit.core.database.entity.api.EntitySerializer;
import ee.yoursit.core.database.entity.impl.Ban;
import org.bson.Document;

import java.util.UUID;

public class BanService {
    public Future<Ban> getBanById(UUID banId) {
        return Future.tryCompleteAsync(() -> {
            Document document = YsmpCore.INSTANCE
                .getDatabase()
                .getInvites()
                .find(Ban.queryId(banId))
                .first();

            return EntitySerializer.deserialize(document, Ban.class);
        });
    }

    public Future<Ban> getBanByTarget(UUID target) {
        return Future.tryCompleteAsync(() -> {
            Document document = YsmpCore.INSTANCE
                .getDatabase()
                .getInvites()
                .find(Ban.queryTarget(target))
                .first();

            return EntitySerializer.deserialize(document, Ban.class);
        });
    }

    public Future<Void> createBan(Ban ban) {
        return Future.tryCompleteAsync(() -> {
            Document document = EntitySerializer.serialize(ban);
            YsmpCore.INSTANCE
                .getDatabase()
                .getInvites()
                .insertOne(document);
        });
    }
}
