package ee.yoursit.core.database.service;

import dev.inventex.octa.concurrent.future.Future;
import ee.yoursit.core.YsmpCore;
import ee.yoursit.core.database.entity.api.EntitySerializer;
import ee.yoursit.core.database.entity.impl.Invite;
import org.bson.Document;

public class InviteService {
    public Future<Invite> getInvite(String code) {
        return Future.tryCompleteAsync(() -> {
            Document document = YsmpCore.INSTANCE
                .getDatabase()
                .getInvites()
                .find(Invite.query(code))
                .first();

            return EntitySerializer.deserialize(document, Invite.class);
        });
    }

    public Future<Void> createInvite(Invite invite) {
        return Future.completeAsync(() -> {
            Document document = EntitySerializer.serialize(invite);
            YsmpCore.INSTANCE
                .getDatabase()
                .getInvites()
                .insertOne(document);
        });
    }
}
