package ee.yoursit.core.database.service;

import dev.inventex.octa.concurrent.future.Future;
import ee.yoursit.core.YsmpCore;
import ee.yoursit.core.database.entity.api.EntitySerializer;
import ee.yoursit.core.database.entity.impl.User;
import ee.yoursit.core.database.entity.impl.Verification;
import org.bson.Document;
import org.bukkit.entity.Player;

import java.util.UUID;

public class VerificationService {
    public Future<Verification> getVerification(String code) {
        return Future.tryCompleteAsync(() -> {
            Document document = YsmpCore.INSTANCE
                .getDatabase()
                .getVerifications()
                .find(Verification.queryCode(code))
                .first();

            return EntitySerializer.deserialize(document, Verification.class);
        });
    }

    public Future<Verification> getVerification(long discordId) {
        return Future.tryCompleteAsync(() -> {
            Document document = YsmpCore.INSTANCE
                .getDatabase()
                .getVerifications()
                .find(Verification.queryId(discordId))
                .first();

            return EntitySerializer.deserialize(document, Verification.class);
        });
    }

    public Future<Verification> getVerification(Player player) {
        return Future.tryCompleteAsync(() -> {
            Document document = YsmpCore.INSTANCE
                .getDatabase()
                .getVerifications()
                .find(Verification.queryName(player.getName()))
                .first();

            return EntitySerializer.deserialize(document, Verification.class);
        });
    }

    public Future<Void> addVerification(Verification verification) {
        return Future.completeAsync(() -> {
            Document document = EntitySerializer.serialize(verification);
            YsmpCore.INSTANCE
                .getDatabase()
                .getVerifications()
                .insertOne(document);
        });
    }

    public Future<Void> removeVerification(Verification verification) {
        return Future.completeAsync(() -> {
            YsmpCore.INSTANCE
                .getDatabase()
                .getVerifications()
                .deleteOne(verification.query());
        });
    }
}
