package ee.yoursit.core.module;

import ee.yoursit.core.YsmpCore;
import ee.yoursit.core.config.Messages;
import net.dv8tion.jda.api.entities.Activity;
import net.dv8tion.jda.api.entities.SelfUser;
import net.dv8tion.jda.api.events.session.ReadyEvent;
import net.dv8tion.jda.api.hooks.ListenerAdapter;
import org.bukkit.Bukkit;

import java.util.Timer;
import java.util.TimerTask;

public class DiscordListener extends ListenerAdapter {
    private static final int ACTIVITY_UPDATE = 1000 * 5;

    private int actionIndex = 0;

    public void onReady(ReadyEvent event) {
        SelfUser user = event.getJDA().getSelfUser();
        System.out.println("Logged in as " + user.getName() + "#" + user.getDiscriminator());

        TimerTask task = new TimerTask() {
            @Override
            public void run() {
                updateActivity();
            }
        };

        Timer timer = new Timer();
        timer.scheduleAtFixedRate(task, ACTIVITY_UPDATE, ACTIVITY_UPDATE);

        YsmpCore.INSTANCE
            .getDiscordCommands()
            .load();
    }

    private void updateActivity() {
        ActivityState[] values = ActivityState.values();
        ActivityState state = values[actionIndex++ % values.length];

        Activity activity = switch (state) {
            case LIST_PLAYERS -> {
                String count = String.valueOf(Bukkit.getOnlinePlayers().size());
                yield Activity.watching(Messages.ACTIVITY_PLAYERS
                    .replace("{count}", count));
            }
            case SHOW_DISCORD_LINK -> Activity.playing(Messages.ACTIVITY_DISCORD);
            case SHOW_SERVER_ADDRESS -> Activity.playing(Messages.ACTIVITY_ADDRESS);
        };

        YsmpCore.INSTANCE
            .getClient()
            .getJda()
            .getPresence()
            .setActivity(activity);
    }

    public enum ActivityState {
        LIST_PLAYERS,
        SHOW_DISCORD_LINK,
        SHOW_SERVER_ADDRESS
    }
}
